#!/usr/local/bin/perl
$Part=0;
$Total=0;
$Fname="";
#------------------------------------------------
sub partget
{
	local( @pl, @pt, $oname );
	if( $_[0] =~/part/i ){
		@pl= split( " |\t", $_[0] );
		@pt= split( "part|Part|PART|/|\n", $pl[1] );
		$Fname=$pl[0];
		$Part=$pt[1];
		$Total=$pt[2];
		$oname=sprintf( "%s.%04d", $pl[0], $pt[1] );
		return	$oname;
	}
}
#------------------------------------------------
sub totalcheck
{
	local( $name )=$_[0];
	local( $total )=$_[1];
	local( $i, $count );
	for( $i= 1, $count= 0 ; $i <= $total ; $i++ ){
		unless( -r sprintf( "%s.%04d", $name, $i ) ){
			$count++;
		}
	}
	return	$count;
}
#------------------------------------------------
sub allclean
{
	local( $name )=$_[0];
	local( $total )=$_[1];
	local( $i );
	for( $i= 1 ; $i <= $total ; $i++ ){
		unlink( sprintf( "%s.%04d", $name, $i ) );
	}
}
#------------------------------------------------
sub decode
{
	local( $name )=$_[0];
	local( $total )=$_[1];
	local( $format )=$_[2];
	local( $i, $cmd );
	if( $format =~/ish/i ){
		$cmd="|aish -";
	}elsif( $format =~/uuencode/i ){
		$cmd="|uudecode";
	}elsif( $format =~/uuen/i ){
		$cmd="|uudecode";
	}else{
		print "unknown format.\n";
		return;
	}
	if( open( POUT, $cmd ) ){
		for( $i= 1 ; $i <= $total ; $i++ ){
			print "  decode - $i/$total\n";
			if( open( IFILE, sprintf( "%s.%04d", $name, $i ) ) ){
				while(<IFILE>){
					print POUT;
				}
				close( IFILE );
			}
		}
		close( POUT );
		&allclean( $name, $total );
		printf( "'%s' decode end\n",$name);
	}else{
		print "command $cmd error\n";
	}
}
#------------------------------------------------
foreach $fname ( @ARGV ){
	unless( open( IMFILE, $fname ) ){
		print "Can't open $fname.\n";
		next;
	}
	while(<IMFILE>){
		if( /^format / || /^Encoded-Format/ ){
			$format=$_;
		}
		if( /^BEGIN/ ){
			$oname= &partget( $pline );
			print $Fname," - ",$Part,"/",$Total," -> ",$oname,"\n";
			if( open( OFILE, ">$oname" ) ){
				while(<IMFILE>){
					if( /^END/ ){
						last;
					}
					print OFILE;
				}
				close( OFILE );
				$count= &totalcheck( $Fname, $Total );
				if( $count == 0 ){
					print "OK!\n";
					&decode( $Fname, $Total, $format );
				}else{
					print " -- $count\n";
				}
			}else{
				print "$oname write error.\n";
				last;
			}
		}
		$pline=$_;
	}
	close( IMFILE );
}
# Copyright 1994 Ogasawara Hiroyuki (COR.)
# oga@dgw.yz.yamagata-u.ac.jp
